#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
#   runPraFoam.py
#
#       regionがある場合は、空fileを作成する
#
#   13/01/12    paraFoam終了後、空fileを削除する事を追加
#      03/17    multiRegionのチェック方法を変更
#      05/04    paraFoamの起動を環境設定後、起動するように修正（「;」→「\n」へ変更）
#      05/08    空file「*.foam」を追加
#      10/19    国際化のため修正
#


import os
import sys
import glob
import pyTreeFoam

def runParaFoam(envFoam):
    OpenFoamEnvFile = envFoam
    wdir = os.getcwd()
    #multiRegionのチェック
    [region, loc, regNames] = pyTreeFoam.checkMultiRegion(wdir)
    if region == True:
        # Regionがある場合、読み込みファイルを作成
        command = ". " + OpenFoamEnvFile + "\n"
        for folder in regNames:
            command = command + "paraFoam -touch -region " + folder + "\n"
        os.system(command)
    # paraFoam を起動
    #   次の行を「;」→「\n」に修正
    command = ". " + OpenFoamEnvFile + "\n paraFoam"
    os.system(command)
    #空fileを削除
    if len(glob.glob("*.OpenFOAM")) > 0:
        command = "rm *.OpenFOAM"
        os.system(command)
    if len(glob.glob("*.foam"))>0:
        command = "rm *.foam"
        os.system(command)


#言語の設定
import gettext
treeFoamPath = os.environ["TreeFoamPath"]
gettext.install("treefoam", treeFoamPath + "/data/locale")

envFoam = sys.argv[1]
runParaFoam(envFoam)

