#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
#   runParallelDialog.py
#
#       並列計算の設定、実行
#
#   12/04/30    新規作成
#      11/02    バグ修正（接続状態確認時、currentDirを設定する様に変更）
#      12/09    multiRegionの分割方法、結果再構築方法を変更
#   13/01/11    メッセージ内容を修正
#      01/19    multiRegionの場合のreconstructParを修正
#      03/16    regionPropertiesの有無でmultiRegionかどうかを判定する様に修正
#      05/09    分割後、timeFolder内にmeshをコピーするように修正
#      05/23    decompose,reconstructでzone取得にバグあり、修正
#      10/15    国際化のため、修正
#      12/21    stdout、stderrの設定（import logFileCreater）を追加
#

# generated by wxGlade 0.6.3 on Mon Apr 30 10:37:28 2012

import wx
import os
import sys
import glob

import setFoamContents
import getFoamContents
import pyTreeFoam
from fileOperationInProcessorDialog import Show as fileOperationInProcessor
from treefoam import machinesFile as treefoamMachinesFile

import logFileCreater; logFileCreater.log()


caseDir = ""

# begin wxGlade: extracode
# end wxGlade



def Show(caseDir1):
    global caseDir
    caseDir = caseDir1
    app = wx.PySimpleApp(0)
    wx.InitAllImageHandlers()
    frame_1 = MyFrame(None, -1, "")
    app.SetTopWindow(frame_1)
    frame_1.Show()
    app.MainLoop()


class MyFrame(wx.Frame):
    def __init__(self, *args, **kwds):
        # begin wxGlade: MyFrame.__init__
        kwds["style"] = wx.DEFAULT_FRAME_STYLE
        wx.Frame.__init__(self, *args, **kwds)
        self.label_1 = wx.StaticText(self, -1, _(u"並列計算の設定、計算開始"))
        self.button_1 = wx.Button(self, -1, _(u"machines編集"))
        self.button_2 = wx.Button(self, -1, _(u"接続状態の確認"))
        self.label_2 = wx.StaticText(self, -1, _(u"並列計算するsubDomainを定義。\n（/etc/hostsで定義されているhostから選択）"))
        self.button_3 = wx.Button(self, -1, _(u"decomposeParDict編集"))
        self.label_3 = wx.StaticText(self, -1, _(u"各cpu毎のmesh分割方法を定義。"))
        self.sizer_2_staticbox = wx.StaticBox(self, -1, _(u"設定ファイルの作成"))
        self.button_4 = wx.Button(self, -1, _(u"mesh分割"))
        self.label_4 = wx.StaticText(self, -1, _(u"cpu毎に領域分割、node毎に領域配布"))
        self.button_8 = wx.Button(self, -1, _(u"各領域のfile操作"))
        self.label_7 = wx.StaticText(self, -1, _(u"各processor内へのファイルコピー、削除"))
        self.sizer_10_staticbox = wx.StaticBox(self, -1, _(u"領域分割"))
        self.button_5 = wx.Button(self, -1, _(u"並列計算開始"))
        self.button_6 = wx.Button(self, -1, _(u"lam(mpi)の停止"))
        self.label_5 = wx.StaticText(self, -1, _(u"並列計算を開始します（mpirun）"))
        self.sizer_4_staticbox = wx.StaticBox(self, -1, _(u"並列計算"))
        self.button_7 = wx.Button(self, -1, _(u"結果の再構築"))
        self.label_6 = wx.StaticText(self, -1, _(u"実行後、cpu毎の計算結果を集め、結果を再構築します。"))
        self.sizer_12_staticbox = wx.StaticBox(self, -1, _(u"結果の確認"))
        self.button_9 = wx.Button(self, -1, _(u"閉じる"))

        self.__set_properties()
        self.__do_layout()

        self.Bind(wx.EVT_BUTTON, self.onEditMachines, self.button_1)
        self.Bind(wx.EVT_BUTTON, self.onCheckNodes, self.button_2)
        self.Bind(wx.EVT_BUTTON, self.onEditDecomposeParDict, self.button_3)
        self.Bind(wx.EVT_BUTTON, self.onDecomposePar, self.button_4)
        self.Bind(wx.EVT_BUTTON, self.onFileOperation, self.button_8)
        self.Bind(wx.EVT_BUTTON, self.onRunMpi, self.button_5)
        self.Bind(wx.EVT_BUTTON, self.onHaltMpi, self.button_6)
        self.Bind(wx.EVT_BUTTON, self.onReconstruct, self.button_7)
        self.Bind(wx.EVT_BUTTON, self.onClose, self.button_9)
        # end wxGlade

    def __set_properties(self):
        # begin wxGlade: MyFrame.__set_properties
        self.SetTitle(_(u"並列計算"))
        self.button_1.SetMinSize((120, 30))
        self.button_4.SetMinSize((120, 30))
        self.button_8.SetMinSize((120, 30))
        self.button_5.SetMinSize((120, 30))
        self.button_7.SetMinSize((120, 30))
        # end wxGlade

    def __do_layout(self):
        # begin wxGlade: MyFrame.__do_layout
        sizer_1 = wx.BoxSizer(wx.VERTICAL)
        sizer_9 = wx.BoxSizer(wx.VERTICAL)
        sizer_14 = wx.BoxSizer(wx.HORIZONTAL)
        self.sizer_12_staticbox.Lower()
        sizer_12 = wx.StaticBoxSizer(self.sizer_12_staticbox, wx.VERTICAL)
        sizer_13 = wx.BoxSizer(wx.HORIZONTAL)
        self.sizer_4_staticbox.Lower()
        sizer_4 = wx.StaticBoxSizer(self.sizer_4_staticbox, wx.VERTICAL)
        sizer_5 = wx.BoxSizer(wx.HORIZONTAL)
        self.sizer_10_staticbox.Lower()
        sizer_10 = wx.StaticBoxSizer(self.sizer_10_staticbox, wx.VERTICAL)
        sizer_7 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_11 = wx.BoxSizer(wx.HORIZONTAL)
        self.sizer_2_staticbox.Lower()
        sizer_2 = wx.StaticBoxSizer(self.sizer_2_staticbox, wx.VERTICAL)
        sizer_8 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_3 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_1.Add(self.label_1, 0, wx.TOP | wx.BOTTOM | wx.ALIGN_CENTER_HORIZONTAL, 10)
        sizer_3.Add(self.button_1, 0, wx.LEFT | wx.RIGHT | wx.TOP, 10)
        sizer_3.Add(self.button_2, 0, wx.LEFT | wx.RIGHT | wx.TOP, 10)
        sizer_2.Add(sizer_3, 0, wx.EXPAND, 0)
        sizer_2.Add(self.label_2, 0, wx.LEFT, 20)
        sizer_8.Add((10, 20), 0, 0, 0)
        sizer_8.Add(self.button_3, 0, wx.TOP | wx.BOTTOM, 5)
        sizer_8.Add(self.label_3, 0, wx.LEFT | wx.ALIGN_CENTER_VERTICAL, 20)
        sizer_2.Add(sizer_8, 1, wx.EXPAND, 0)
        sizer_1.Add(sizer_2, 0, wx.ALL | wx.EXPAND, 5)
        sizer_11.Add((10, 20), 0, 0, 0)
        sizer_11.Add(self.button_4, 0, wx.TOP | wx.BOTTOM, 2)
        sizer_11.Add(self.label_4, 0, wx.LEFT | wx.ALIGN_CENTER_VERTICAL, 20)
        sizer_10.Add(sizer_11, 0, wx.EXPAND, 0)
        sizer_7.Add((10, 20), 0, 0, 0)
        sizer_7.Add(self.button_8, 0, wx.TOP | wx.BOTTOM, 2)
        sizer_7.Add(self.label_7, 0, wx.LEFT | wx.ALIGN_CENTER_VERTICAL, 20)
        sizer_10.Add(sizer_7, 0, wx.EXPAND, 0)
        sizer_1.Add(sizer_10, 1, wx.ALL | wx.EXPAND, 5)
        sizer_5.Add(self.button_5, 0, wx.LEFT | wx.RIGHT | wx.TOP, 10)
        sizer_5.Add(self.button_6, 0, wx.LEFT | wx.RIGHT | wx.TOP, 10)
        sizer_4.Add(sizer_5, 0, wx.EXPAND, 0)
        sizer_4.Add(self.label_5, 0, wx.LEFT, 20)
        sizer_1.Add(sizer_4, 0, wx.ALL | wx.EXPAND, 5)
        sizer_13.Add(self.button_7, 0, wx.LEFT | wx.RIGHT | wx.TOP, 10)
        sizer_12.Add(sizer_13, 0, wx.EXPAND, 0)
        sizer_12.Add(self.label_6, 0, wx.LEFT, 20)
        sizer_1.Add(sizer_12, 0, wx.ALL | wx.EXPAND, 5)
        sizer_14.Add(self.button_9, 0, wx.ALL | wx.ALIGN_RIGHT, 10)
        sizer_9.Add(sizer_14, 0, wx.ALIGN_RIGHT, 0)
        sizer_1.Add(sizer_9, 0, wx.EXPAND, 0)
        self.SetSizer(sizer_1)
        sizer_1.Fit(self)
        self.Layout()
        # end wxGlade

    #machines編集
    def onEditMachines(self, event): # wxGlade: MyFrame.<event_handler>
        print _(u"並列計算：machinesを編集します。")
        self.editMachines()
        event.Skip()

    #接続状態の確認
    def onCheckNodes(self, event): # wxGlade: MyFrame.<event_handler>
        print _(u"並列計算：接続状態を確認します。")
        self.checkConnectedNodes()
        event.Skip()

    #decomposeParDict編集
    def onEditDecomposeParDict(self, event): # wxGlade: MyFrame.<event_handler>
        print _(u"並列計算：decomposeParDictを編集します。")
        self.editDecomposeParDict()
        event.Skip()

    #メッシュ分割
    def onDecomposePar(self, event): # wxGlade: MyFrame.<event_handler>
        print _(u"並列計算：メッシュを分割します。")
        self.runDecomposePar()
        event.Skip()

    #メッシュ分配
    def onDistToNode(self, event): # wxGlade: MyFrame.<event_handler>
        print "Event handler `onDistToNode' not implemented!"
        event.Skip()

    #processor内のfile操作
    def onFileOperation(self, event): # wxGlade: MyFrame.<event_handler>
        print _(u"processor内のfile操作")
        self.fileOperation()
        event.Skip()

    #並列計算開始
    def onRunMpi(self, event): # wxGlade: MyFrame.<event_handler>
        print _(u"並列計算を開始します。")
        self.runMpi()
        event.Skip()

    def onHaltMpi(self, event): # wxGlade: MyFrame.<event_handler>
        print _(u"lam, mpiを停止します。")
        self.haltMpi()
        event.Skip()

    def onReconstruct(self, event): # wxGlade: MyFrame.<event_handler>
        print _(u"結果を集め再構築します。")
        self.reconstruct()
        event.Skip()

    #Close
    def onClose(self, event): # wxGlade: MyFrame.<event_handler>
        self.Destroy()
        event.Skip()


    #  editMachies
    #    machinesの編集
    def editMachines(self):
        global caseDir
        machinesFile = treefoamMachinesFile
        fileName = caseDir + "/" + machinesFile
        if len(glob.glob(fileName)) == 0:
            cont = setFoamContents.makeMachinesDefault()
            f=open(fileName,"w"); f.write(cont); f.close()
            msg = _(u"machinesがなかったので、標準の「machines」を作成しました。\n 「localhost cpu=4」で作成しています。")
            self.okDialog(_(u"並列計算"), msg)
        pyTreeFoam.runEditor(fileName)

    #  checkConnectedNodes
    #    接続状態を確認
    def checkConnectedNodes(self):
        global caseDir
        machinesFile = treefoamMachinesFile
        fileName = caseDir + "/" + machinesFile
        if len(glob.glob(fileName)) == 0:
            title = _(u"nodeの表示")
            message = _(u"現在の解析Case内に「mashines」ファイルがありません。\n「machines」で並列計算させるノードを設定してください。")
            self.errDialog(title, message)
            return
        tempFile = caseDir + "/nodes.temp"
        command = "cd " + caseDir + ";lamboot -v machines; lamnodes | tee " + tempFile + "; lamhalt -d"
        pyTreeFoam.runOFUtility(command)
        f=open(tempFile); cont=f.read(); f.close()
        message = _(u"接続されているノードを表示します。\n\nnode\t内容\n-------------------------------------\n") + cont
        os.system("rm -rf " + tempFile)
        title = _(u"nodeの表示")
        self.okDialog(title, message)

    #  editDecomposeParDict
    #    decomposeParDictを編集する
    def editDecomposeParDict(self):
        global caseDir
        fileName = caseDir + "/system/decomposeParDict"
        if len(glob.glob(fileName)) == 0:
            cont = setFoamContents.makeDecomposeParDictDefault()
            f=open(fileName,"w"); f.write(cont); f.close()
            msg = _(u"deconposeParDictが無かったので、標準のdecomposeParDictを作成しました。")
            self.okDialog(_(u"decomposeParDictの編集"), msg)
        pyTreeFoam.runEditor(fileName) 


    #  runDecomposePar
    #    meshをcpu毎に分割
    def runDecomposePar(self):
        global caseDir
        fileName = caseDir + "/system/decomposeParDict"
        if len(glob.glob(fileName)) == 0:
            title = _(u"エラー")
            message = _(u"systemフォルダ内に「decomposeParDict」がありません。\n作成した上で実行してください。")
            self.errDialog(title, message)
            return

        saveDir = os.getcwd()
        os.chdir(caseDir)
        #既に分割ファイルがある場合は、削除する
        processorfile = caseDir + "/processor*"
        nCPU = len(glob.glob(caseDir + "/processor*"))
        if nCPU != 0:
            while nCPU > 0:
                cpuName = str(nCPU-1)
                command = "rm -rf processor" + cpuName
                print command
                os.system(command)
                nCPU -= 1
        #領域分割
        #if len(glob.glob("./constant/cellToRegion")) != 0:
        if len(glob.glob("./constant/regionProperties")) != 0:
            #cellToRegionで領域分割されている場合
            [fluid, solid] = pyTreeFoam.getZonesInRegionProperties(caseDir)
            zones = fluid + solid
            for zone in zones:
                comm = "cp system/decomposeParDict system/" + zone
                os.system(comm)
                comm = "decomposePar -region " + zone
                [stat, cont] = pyTreeFoam.runOFUtilityReturnStat(comm)
                if stat != "OK":
                    break
            #meshをtimeFolder内にもコピー
            stat = self.distMeshTimeFolderRegion(caseDir, zones)
            message = _(u"cpu > region 毎にメッシュを分割しました。")
        else:
            #decomposeParで分割
            comm = "decomposePar"
            [stat, cont] = pyTreeFoam.runOFUtilityReturnStat(comm)
            """
            if stat == "OK":
                stat = self.distMeshTimeFolder(caseDir)
            """
            message = _(u"cpu 毎にメッシュを分割しました。")

        if stat != "OK":
            title = _(u"エラー")
            message = _(u"エラーが発生しました。\n　logを確認してください。")
            self.errDialog(title, message)
        else:
            title = _(u"並列計算")
            self.okDialog(title, message)
        os.chdir(saveDir)

    #
    #  distMeshTimeFolderRegion
    #    分割したmeshをtimeFolderにコピーする
    def distMeshTimeFolderRegion(self, caseDir, zones):
        times = pyTreeFoam.getTimeFolders(caseDir)
        if len(times) == 0:
            return "NG"

        nPro = len(glob.glob(caseDir + "/processor*"))
        timeFolder = times[0]
        i=0
        while i<nPro:
            for zone in zones:
                copyDir = caseDir + "/processor" + str(i) + "/constant/" + zone + "/polyMesh"
                distDir = caseDir + "/processor"+str(i)+"/" + timeFolder + "/" + zone
                if len(glob.glob(copyDir)) != 0:
                    comm = "cp -r " + copyDir + " " + distDir
                    os.system(comm)
            i += 1
        return "OK"

    #  distMeshTimeFolder
    #    分割したmeshをtimeFolderにコピーする。
    def distMeshTimeFolder(self, caseDir):
        times = pyTreeFoam.getTimeFolders(caseDir)
        if len(times) == 0:
            return "NG"

        timeFolder = times[0]
        copyDir = caseDir + "/constant/polyMesh"
        distDir = caseDir + "/" + timeFolder
        if len(glob.glob(copyDir)) != 0:
            comm = "cp -r " + copyDir + " " + distDir
            os.system(comm)
        return "OK"

    #  fileOperation
    #    各processor内のfile操作
    def fileOperation(self):
        global caseDir
        fileOperationInProcessor(caseDir)

    #  runMpi
    #    並列計算開始
    def runMpi(self):
        global caseDir
        solver = pyTreeFoam.getSolver(caseDir)
        nCpu = len(glob.glob(caseDir + "/processor*"))
        if solver != "" and nCpu>1:
            #dir保存
            saveDir = os.getcwd()
            os.chdir(caseDir)
            #solve.ogのクリア
            f=open("solve.log", "w"); f.close()
            #solverの実行ファイル作成
            envOF = pyTreeFoam.getBashrcFoam()
            cont  = "#!/bin/bash\n"
            cont += ". " + envOF + "\n"
            cont += "lamboot -v machines\n"
            cont += "mpirun -np " + str(nCpu) + " " + solver + " -parallel | tee solve.log\n"
            f=open("run", "w"); f.write(cont); f.close()
            #実行権付与
            os.system("chmod a+x run")
            #実行
            caseName = caseDir.split("/")[-1]
            comm = "gnome-terminal -t " + caseName + " --geometry=120x20 --zoom=0.9 -x bash --rcfile run &"
            os.system(comm)
            #dirを元に戻す
            os.chdir(saveDir)
        else:
            title = _(u"エラー")
            if solver == "":
                message = _(u"「controlDict」は、存在しません。\n")
                message += _(u"  case directoryが間違っています。")
            else:
                message = _(u"メッシュが並列計算用に領域分割されていません。") 
            self.okDialog(title, message)

    #  haltMpi
    #    lam, mpiの中断
    def haltMpi(self):
        global caseDir
        saveDir = os.getcwd()
        os.chdir(caseDir)
        comm = "lamhalt -d"
        pyTreeFoam.runOFUtility(comm)
        os.chdir(saveDir)
        print _(u"\nlamを停止しました。")

    #  reconstruct
    #    結果を再構築します
    def reconstruct(self):
        global caseDir
        saveDir = os.getcwd()
        os.chdir(caseDir)
        #if len(glob.glob("./constant/cellToRegion")) != 0:
        if len(glob.glob("./constant/regionProperties")) != 0:
            [fluid, solid] = pyTreeFoam.getZonesInRegionProperties(caseDir)
            zones = fluid + solid
            for zone in zones:
                comm = "reconstructPar -region " + zone + " -zeroTime"
                print comm
                [stat, cont] = pyTreeFoam.runOFUtilityReturnStat(comm)
                if stat != "OK":
                    break
        else:
            comm = "reconstructPar"
            print comm
            [stat, cont] = pyTreeFoam.runOFUtilityReturnStat(comm)
        if stat == "OK":
            title = _(u"結果の再構築")
            message = _(u"並列計算結果を再構築しました。")
            self.okDialog(title, message)
        else:
            title = _(u"エラー")
            message = _(u"結果の再構築中に、エラーが発生しました。\n  logを確認してください。")
            self.errDialog(title, message)
        os.chdir(saveDir)


    #------------------------------
    def okDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_INFORMATION) 
        dlg.ShowModal()
        dlg.Destroy()

    def errDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_HAND) 
        dlg.ShowModal()
        dlg.Destroy()


# end of class MyFrame


if __name__ == "__main__":
    import gettext
    treeFoamPath = os.environ["TreeFoamPath"]
    gettext.install("treefoam", treeFoamPath + "/data/locale")

    caseDir = sys.argv[1]
    app = wx.PySimpleApp(0)
    wx.InitAllImageHandlers()
    frame_1 = MyFrame(None, -1, "")
    app.SetTopWindow(frame_1)
    frame_1.Show()
    app.MainLoop()
