#!/usr/bin/env python
# -*- coding: utf-8 -*-
# generated by wxGlade 0.6.3 on Tue Apr 12 20:25:30 2011
#
#   setDataInFieldsDialog.py
#
#   各fieldへのデータセット（クリア）
#
#       programed by s.fujii
#       11/04/10    新規作成
#       12/07/16    編集するtimeFolderの変更ができる様に変更
#       13/05/09    field選択dialogを変更
#          06/30    timeFolder選択方法、region選択追加
#          07/02    fields, cellSetsのリスト表示追加
#          07/13    選択fieldsをclearInternal、zeroGradientに引き継ぐ様に修正
#                   setFieldsDict時にfield、setsを選択するとこれを使ってDict作成
#          07/17    gridEditor, topoSetEditorの起動を追加
#          07/27    setFieldsでOF2.1以下は「-region」オプション使えない事の表示追加
#          09/25    getFieldTypeのバグ修正
#          10/15    国際化のため、修正
#          12/02    setFieldsDict作成をgridで編集できる様に修正
#          12/21    stdout、stderrの設定（import logFileCreater）を追加
#

import wx
import glob
import os
import sys
import pyTreeFoam
import setFoamContents
import getFoamContents
import topoSetEditor
from selectFolderFilesDialog import selRegShow as selectFieldsDialogSelRegShow, selRegFileShow as selectFieldsDialogSelRegFileShow
from selectFolderFilesDialog import clearBoundaryOrInternal as clearBoundaryOrInternal
from editBoundaryConditionsDialog import readConfigData as readGridEditorConfig

import logFileCreater; logFileCreater.log()


timeFolders = []
regionNames = []
fields = []
cellSets = []
selFiles = []
selCellSets = []
selRegion = ""
timeFolder = ""
startFrom = ""
caseDir = ""
firstTime = ""
startTime = ""
latestTime = ""


# begin wxGlade: extracode
# end wxGlade



def Show(wdir, folder):
    global caseDir, timeFolder
    caseDir = wdir
    timeFolder = folder
    wx.InitAllImageHandlers()
    app = wx.PySimpleApp(0)
    frame_1 = MyFrame(None, -1, "")
    app.SetTopWindow(frame_1)
    frame_1.Show()
    app.MainLoop()



class MyFrame(wx.Frame):
    def __init__(self, *args, **kwds):
        # begin wxGlade: MyFrame.__init__
        kwds["style"] = wx.DEFAULT_FRAME_STYLE
        wx.Frame.__init__(self, *args, **kwds)
        self.label_1 = wx.StaticText(self, -1, _(u"各Fieldへのデータセット"))
        self.static_line_1 = wx.StaticLine(self, -1)
        self.label_3 = wx.StaticText(self, -1, _("time"))
        self.combo_box_1 = wx.ComboBox(self, -1, choices=[], style=wx.CB_DROPDOWN)
        self.label_6 = wx.StaticText(self, -1, _("region"))
        self.combo_box_2 = wx.ComboBox(self, -1, choices=[], style=wx.CB_DROPDOWN)
        self.sizer_12_staticbox = wx.StaticBox(self, -1, _(u"編集するfolder"))
        self.label_10 = wx.StaticText(self, -1, _("cellSets"))
        self.list_box_2 = wx.ListBox(self, -1, choices=[], style=wx.LB_MULTIPLE)
        self.button_8 = wx.Button(self, -1, _(u"cellSet作成"))
        self.label_12 = wx.StaticText(self, -1, _(u"topoSetEditor起動"))
        self.label_2 = wx.StaticText(self, -1, _("fields"))
        self.list_box_1 = wx.ListBox(self, -1, choices=[], style=wx.LB_MULTIPLE)
        self.button_7 = wx.Button(self, -1, _(u"field内容確認"))
        self.label_11 = wx.StaticText(self, -1, _(u"gridEditor起動"))
        self.button_3 = wx.Button(self, -1, _(u"setFieldsDict作成..."))
        self.label_4 = wx.StaticText(self, -1, _(u"cellSet, fieldを選択後、クリックして、\nsetDieldsDict用のデータを作成する"))
        self.sizer_14_staticbox = wx.StaticBox(self, -1, _(u"setFieldsDict作成"))
        self.button_1 = wx.Button(self, -1, _(u"setFieldsDict編集"))
        self.button_2 = wx.Button(self, -1, _(u"setFields実行..."))
        self.button_5 = wx.Button(self, -1, _(u"systemフォルダ開く"))
        self.sizer_4_staticbox = wx.StaticBox(self, -1, _(u"setFields実行"))
        self.static_line_2 = wx.StaticLine(self, -1)
        self.button_4 = wx.Button(self, -1, _("internalField..."))
        self.button_9 = wx.Button(self, -1, _("boundaryField..."))
        self.sizer_8_staticbox = wx.StaticBox(self, -1, _(u"fieldのクリア"))
        self.button_6 = wx.Button(self, -1, _(u"閉じる"))

        self.__set_properties()
        self.__do_layout()

        self.Bind(wx.EVT_TEXT_ENTER, self.onChangeTimeFolder, self.combo_box_1)
        self.Bind(wx.EVT_COMBOBOX, self.onChangeTimeFolder, self.combo_box_1)
        self.Bind(wx.EVT_TEXT_ENTER, self.onChangeRegion, self.combo_box_2)
        self.Bind(wx.EVT_COMBOBOX, self.onChangeRegion, self.combo_box_2)
        self.Bind(wx.EVT_BUTTON, self.onRunTopoSetEditor, self.button_8)
        self.Bind(wx.EVT_BUTTON, self.onRunGridEditor, self.button_7)
        self.Bind(wx.EVT_BUTTON, self.onCreateSetFieldsDict, self.button_3)
        self.Bind(wx.EVT_BUTTON, self.onEditSetFields, self.button_1)
        self.Bind(wx.EVT_BUTTON, self.onRunSetFields, self.button_2)
        self.Bind(wx.EVT_BUTTON, self.onOpenSystemFolder, self.button_5)
        self.Bind(wx.EVT_BUTTON, self.onClearInternalFields, self.button_4)
        self.Bind(wx.EVT_BUTTON, self.onZeroGradient, self.button_9)
        self.Bind(wx.EVT_BUTTON, self.onClose, self.button_6)
        # end wxGlade

    def __set_properties(self):
        # begin wxGlade: MyFrame.__set_properties
        self.SetTitle(_(u"Fieldへのデータセット"))
        self.list_box_2.SetMinSize((190, 120))
        self.button_8.SetMinSize((98, 30))
        self.list_box_1.SetMinSize((36, 66))
        self.button_7.SetMinSize((99, 30))
        self.button_3.SetMinSize((180, 40))
        # end wxGlade
        mess = _(u"timeFolder内の各Fieldへのデータセット（クリア）")
        self.label_1.SetLabel(mess)
        #コンボボックスの設定
        self.setComboBox()
        self.setRegions()
        #リストボックスの設定
        self.setNamesInListBox(fields, cellSets)
        #self.selectNamesInListBox(selFields, selCellSets)


    def __do_layout(self):
        # begin wxGlade: MyFrame.__do_layout
        sizer_3 = wx.BoxSizer(wx.VERTICAL)
        sizer_10 = wx.GridSizer(1, 1, 0, 0)
        sizer_11 = wx.BoxSizer(wx.HORIZONTAL)
        self.sizer_8_staticbox.Lower()
        sizer_8 = wx.StaticBoxSizer(self.sizer_8_staticbox, wx.VERTICAL)
        sizer_13 = wx.BoxSizer(wx.HORIZONTAL)
        self.sizer_4_staticbox.Lower()
        sizer_4 = wx.StaticBoxSizer(self.sizer_4_staticbox, wx.HORIZONTAL)
        self.sizer_14_staticbox.Lower()
        sizer_14 = wx.StaticBoxSizer(self.sizer_14_staticbox, wx.VERTICAL)
        sizer_17 = wx.BoxSizer(wx.VERTICAL)
        sizer_18 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_16 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_5 = wx.BoxSizer(wx.VERTICAL)
        sizer_6 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_15 = wx.BoxSizer(wx.VERTICAL)
        sizer_7 = wx.BoxSizer(wx.HORIZONTAL)
        self.sizer_12_staticbox.Lower()
        sizer_12 = wx.StaticBoxSizer(self.sizer_12_staticbox, wx.VERTICAL)
        sizer_1 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_9 = wx.BoxSizer(wx.VERTICAL)
        sizer_2 = wx.BoxSizer(wx.VERTICAL)
        sizer_3.Add(self.label_1, 0, wx.TOP | wx.BOTTOM | wx.ALIGN_CENTER_HORIZONTAL, 10)
        sizer_3.Add(self.static_line_1, 0, wx.LEFT | wx.RIGHT | wx.BOTTOM | wx.EXPAND, 5)
        sizer_2.Add(self.label_3, 0, wx.LEFT, 10)
        sizer_2.Add(self.combo_box_1, 0, wx.LEFT | wx.RIGHT | wx.EXPAND, 5)
        sizer_1.Add(sizer_2, 1, wx.EXPAND, 0)
        sizer_9.Add(self.label_6, 0, wx.LEFT, 10)
        sizer_9.Add(self.combo_box_2, 0, wx.LEFT | wx.RIGHT | wx.EXPAND, 5)
        sizer_1.Add(sizer_9, 1, wx.EXPAND, 0)
        sizer_12.Add(sizer_1, 0, wx.LEFT | wx.RIGHT | wx.BOTTOM | wx.EXPAND, 10)
        sizer_3.Add(sizer_12, 0, wx.LEFT | wx.RIGHT | wx.BOTTOM | wx.EXPAND, 10)
        sizer_15.Add(self.label_10, 0, wx.LEFT, 10)
        sizer_15.Add(self.list_box_2, 1, wx.LEFT | wx.BOTTOM | wx.EXPAND, 5)
        sizer_7.Add(self.button_8, 0, wx.LEFT, 5)
        sizer_7.Add(self.label_12, 0, wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_15.Add(sizer_7, 0, wx.EXPAND, 0)
        sizer_16.Add(sizer_15, 1, wx.EXPAND, 0)
        sizer_16.Add((10, 20), 0, 0, 0)
        sizer_5.Add(self.label_2, 0, wx.LEFT, 10)
        sizer_5.Add(self.list_box_1, 1, wx.RIGHT | wx.BOTTOM | wx.EXPAND, 5)
        sizer_6.Add(self.button_7, 0, wx.LEFT, 5)
        sizer_6.Add(self.label_11, 0, wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_5.Add(sizer_6, 0, wx.EXPAND, 0)
        sizer_16.Add(sizer_5, 1, wx.EXPAND, 0)
        sizer_14.Add(sizer_16, 1, wx.EXPAND, 0)
        sizer_18.Add(self.button_3, 0, wx.LEFT | wx.TOP | wx.BOTTOM, 5)
        sizer_18.Add(self.label_4, 0, wx.RIGHT | wx.ALIGN_CENTER_VERTICAL, 10)
        sizer_17.Add(sizer_18, 0, wx.EXPAND, 0)
        sizer_14.Add(sizer_17, 0, wx.EXPAND, 0)
        sizer_3.Add(sizer_14, 1, wx.LEFT | wx.RIGHT | wx.BOTTOM | wx.EXPAND, 10)
        sizer_4.Add(self.button_1, 0, wx.LEFT | wx.BOTTOM, 3)
        sizer_4.Add(self.button_2, 0, wx.LEFT, 3)
        sizer_4.Add(self.button_5, 0, wx.LEFT | wx.BOTTOM, 3)
        sizer_3.Add(sizer_4, 0, wx.LEFT | wx.RIGHT | wx.BOTTOM | wx.EXPAND, 10)
        sizer_3.Add(self.static_line_2, 0, wx.ALL | wx.EXPAND, 5)
        sizer_13.Add(self.button_4, 0, wx.LEFT, 3)
        sizer_13.Add(self.button_9, 0, wx.LEFT, 3)
        sizer_8.Add(sizer_13, 0, wx.BOTTOM | wx.EXPAND, 5)
        sizer_3.Add(sizer_8, 0, wx.LEFT | wx.RIGHT | wx.EXPAND, 10)
        sizer_11.Add(self.button_6, 0, wx.ALL | wx.ALIGN_RIGHT, 15)
        sizer_10.Add(sizer_11, 1, wx.ALIGN_RIGHT, 0)
        sizer_3.Add(sizer_10, 0, wx.EXPAND, 0)
        self.SetSizer(sizer_3)
        sizer_3.Fit(self)
        self.Layout()
        # end wxGlade

    #コンボボックスの設定
    def setComboBox(self):
        global caseDir, startFrom, timeFolders, firstTime, startTime, latestTime
        items = []
        items.append("firstTime :" + firstTime)
        items.append("startTime :" + startTime)
        items.append("latestTime:" + latestTime)
        self.combo_box_1.Clear()
        self.combo_box_1.AppendItems(items)
        if startFrom == "firstTime":
            self.combo_box_1.SetSelection(0)
        elif startFrom == "startTime":
            self.combo_box_1.SetSelection(1)
        else:
            self.combo_box_1.SetSelection(2)

    #  getTimeFolder
    #    選択しているtimeFolderを取得
    def getTimeFolder(self):
        selTime = self.combo_box_1.GetStringSelection()
        startFrom = selTime.split(":")[0].split()[0]
        timeFolder = selTime.split(":")[1]
        return [startFrom, timeFolder]

    #  setRegions
    #    regionをセット
    def setRegions(self):
        global regionNames
        regions = []
        regions.append("(region0)")
        regions = regions + regionNames[1:]
        self.combo_box_2.Clear()
        self.combo_box_2.AppendItems(regions)
        self.combo_box_2.SetSelection(0)

    #  getSelRegion
    #    選択しているregionを取得
    def getSelRegion(self):
        n = self.combo_box_2.GetSelection()
        if n == 0:
            region = "."
        else:
            region = self.combo_box_2.GetStringSelection()
        return region

    #  setNamesInListBox
    #    listBoxに表示
    def setNamesInListBox(self, fields, cellSets):
        self.list_box_1.Clear()
        self.list_box_1.AppendItems(fields)
        self.list_box_2.Clear()
        self.list_box_2.AppendItems(cellSets)
        #選択項目を表示
        for field in selFields:
            self.list_box_1.SetStringSelection(field)
        for cellSet in selCellSets:
            self.list_box_2.SetStringSelection(cellSet)


    def onRunGridEditor(self, event):  # wxGlade: MyFrame.<event_handler>
        global caseDir, timeFolder, selRegion
        nn = self.list_box_1.GetSelections()
        if len(nn) == 0:
            mess = _(u"fieldを選択してください。")
            self.errDialog(_(u"エラー"), mess)
            return
        fields = []
        for n in nn:
            fields.append(self.list_box_1.GetString(n))
        setDisplayFields(caseDir, timeFolder, selRegion, fields)
        caseFolder = caseDir.split("/")[-1]
        fieldDir = caseDir + "/" + timeFolder + "/" + selRegion
        title = ": " + caseFolder + "/" + timeFolder + "/" + selRegion
        boundaryDir = getFoamContents.getCurrMeshDir(caseDir, timeFolder, selRegion, "boundary")
        comm = "runGridEditor.py "
        comm+= "-1" + " '" + title + "' " + boundaryDir + " " + fieldDir
        comm+= " &"
        os.system(comm)

    def onRunTopoSetEditor(self, event):  # wxGlade: MyFrame.<event_handler>
        global caseDir, timeFolder, selRegion
        stlDir = caseDir
        comm = "cd " + caseDir + ";" 
        comm += "topoSetEditor.py " + caseDir + " " + stlDir
        comm += " " + timeFolder + " " + selRegion
        pyTreeFoam.runOFUtility(comm)
        self.onChangeTimeFolder(event)

    def onChangeTimeFolder(self, event): # wxGlade: MyFrame.<event_handler>
        global caseDir, timeFolder, selRegion
        [startFrom, timeFolder] = self.getTimeFolder()
        selRegion = self.getSelRegion()
        systemDir = caseDir + "/system"
        setFoamContents.controlDict(systemDir, [["startFrom", startFrom]])
        [fields, cellSets] = getFieldsCellSets(caseDir, timeFolder, selRegion)
        self.setNamesInListBox(fields, cellSets)


    def onEditSetFields(self, event): # wxGlade: MyFrame.<event_handler>
        global selRegion
        print _(u"setFieldsDictを編集します。")
        fileName = "./system/" + selRegion + "/setFieldsDict"
        files = glob.glob(fileName)
        if len(files) == 0:
            [fields, cellSets] = self.getSelFieldsCellSets()
            if len(fields) == 0:
                mess = _(u"fieldをlistBoxから選択してください。\n\ncellSetも選択すると選択したfieldに対し、cellToCellでsetFieldsDictを作成します。")
                self.errDialog(_(u"エラー"), mess)
                return
            else:
                if len(cellSets) == 0:
                    mess = _(u"cellSetが選択されていません。\n\n選択されたfieldに対し、boxToCellでsetFieldsDictを作成します。")
                    result = self.okCancelDialog(_(u"setFieldsDict作成"), mess)
                    if result != "OK":
                        return
                cont = makeSetFieldsDictForFieldsSets(fields, cellSets)
            f=open(fileName, "w"); f.write(cont); f.close()
            msg = _(u"setFieldsDictがなかったので、新たに「setFieldsDict」を作成しました。")
            self.okDialog(_(u"setFieldsDictの編集"), msg)
        openFiles = fileName
        pyTreeFoam.runEditor(openFiles)


    def onRunSetFields(self, event): # wxGlade: MyFrame.<event_handler>
        print _(u"setFieldsを実行します。")
        title = u"setFields"
        message = _(u"Fieldにデータをセットします。\n　（setFieldsの実行）")
        ans = self.okCancelDialog(title, message)
        if ans == "OK":
            if selRegion == ".":
                command = "setFields"
            else:
                OFversion = pyTreeFoam.readConfigTreeFoam()[0]
                if OFversion >= "2.2.0":
                    command = "setFields -region " + selRegion
                else:
                    mess = _(u"OF-2.1 以下は、「-region」オプションが使えません。")
                    self.errDialog(_(u"エラー"), mess)
                    return

            print command
            [stat, cont] = pyTreeFoam.runOFUtilityReturnStat(command)
            title = u"setFields"
            if stat == "OK":
                message = _(u"「setFields」でFieldにデータをセットしました。")
                self.okDialog(title, message)
            else:
                message = _(u"エラーが発生しました。\n　logを確認してください。")
                self.errDialog(title, message)

    def onOpenSystemFolder(self, event):  # wxGlade: MyFrame.<event_handler>
        global caseDir, selRegion
        folderDir = caseDir + "/system/" + selRegion
        #os.system(("nautilus " + folderDir).encode("utf-8"))
        pyTreeFoam.openFolderNautilus(folderDir)

    def onClearInternalFields(self, event): # wxGlade: MyFrame.<event_handler>
        global caseDir, timeFolder, selRegion, selFiles
        nn = self.list_box_1.GetSelections()
        selFiles = []
        for n in nn:
            selFiles.append(self.list_box_1.GetString(n))
        editDir = caseDir + "/" + timeFolder
        FFlist = pyTreeFoam.setEditFolders(editDir)
        job = "clearInternal"
        title = _("Internal Field のクリア")
        img = "internal"
        mess = _(u"選択された Internal Field をクリアします。\n  list → uniformに変更します。\n  元々internalFieldがuniform形式なら、変更せずそのまま。")
        selectFieldsDialogSelRegFileShow(job, title, img, mess, editDir, selRegion, selFiles)

    def onClose(self, event): # wxGlade: MyFrame.<event_handler>
        #self.Close(True)
        self.Destroy()

    def onZeroGradient(self, event): # wxGlade: MyFrame.<event_handler>
        global caseDir, timeFolder, selFiles
        nn = self.list_box_1.GetSelections()
        selFiles = []
        for n in nn:
            selFiles.append(self.list_box_1.GetString(n))
        editDir = caseDir + "/" + timeFolder
        job = "clearBoundary"
        title = _(u"boundary Field のクリア")
        img = "boundary"
        mess = _(u"選択された boundary Field を「zeroGradient」でクリアします。")
        selectFieldsDialogSelRegFileShow(job, title, img, mess, editDir, selRegion, selFiles)


    def onChangeRegion(self, event):  # wxGlade: MyFrame.<event_handler>
        self.onChangeTimeFolder(event)

    #setFieldsDict作成
    def onCreateSetFieldsDict(self, event):  # wxGlade: MyFrame.<event_handler>
        self.createSetFieldsDict(event)

# end of class MyFrame

    #
    #  createSetFieldsDict
    #    setFieldsDictを作成
    def createSetFieldsDict(self, event):
        global selFields, selCellSets
        [selFields, selCellSets] = self.getSelFieldsCellSets()
        selectedFields = " ".join(selFields)
        selectedCellSets = " ".join(selCellSets)
        comm = "createSetFieldsDictDialog.py -f " + selectedFields + " -c " + selectedCellSets + " -r " + selRegion + " -t " + timeFolder + " &"
        os.system(comm)


    #  getSelFieldsCellSets
    #    選択しているfield、setsを取得
    def getSelFieldsCellSets(self):
        fields = []
        nn = self.list_box_1.GetSelections()
        for n in nn:
            field = self.list_box_1.GetString(n)
            fields.append(field)
        sets = []
        nn = self.list_box_2.GetSelections()
        for n in nn:
            cellSet = self.list_box_2.GetString(n)
            sets.append(cellSet)
        return [fields, sets]


    def okCancelDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                             wx.OK | wx.CANCEL | wx.ICON_INFORMATION) 
        ans = dlg.ShowModal()
        if ans == wx.ID_OK:
            dlg.Destroy()
            return "OK"
        else:
            dlg.Destroy()
            return "CANCEL"

    def okDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_INFORMATION) 
        dlg.ShowModal()
        dlg.Destroy()

    def errDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_HAND) 
        dlg.ShowModal()
        dlg.Destroy()

#  setDisplayFields
#    gridEditorで表示するfieldをセット
def setDisplayFields(caseDir, timeFolder, region, fields):
    fieldDir = caseDir + "/" + timeFolder + "/" + region
    pyTreeFoam.saveDisplayFields(fields, fieldDir)


#  makeSetFieldsDictForFieldsSets
#    filed, setsからsetFieldsDictを作成する
def makeSetFieldsDictForFieldsSets(fields, sets):
    fieldTypes = []
    [a1, a2, a3, nMaxLines] = readGridEditorConfig()
    for field in fields:
        fieldType = getFieldType(field, nMaxLines)
        fieldTypes.append(fieldType)
    #defaultFieldValuesの作成
    contents = "defaultFieldValues\n(\n"
    i = 0
    for fieldType in fieldTypes:
        if fieldType.find("Scalar") >= 0:
            fieldValue = fieldType + "Value " + fields[i] + " 0"
        elif fieldType.find("Vector") >= 0:
            fieldValue = fieldType + "Value " + fields[i] + " (0 0 0)"
        elif fieldType.find("SymmTensor") >= 0:
            fieldValue = fieldType + "Value " + fields[i] + " (0 0 0 0 0 0)"
        elif fieldType.find("Tensor") >= 0:
            fieldValue = fieldType + "Value " + fields[i] + " (0 0 0 0 0 0 0 0 0)"
        else:
            fieldValue = fieldType + "Value " + fields[i] + " 0"
        contents += "    " + fieldValue + "\n"
        i += 1
    contents += ");\n\n"
    #regionsの作成
    contents += "regions\n(\n"
    if len(sets) == 0:
        #boxToCellで作成
        contents += makeRegionsForBoxToCell(fields, fieldTypes)
    else:
        #cellSetで作成
        contents += makeRegionsForSets(fields, fieldTypes, sets)
    contents += ");\n"
    #setFieldsDict作成
    OFversion = pyTreeFoam.getOFversion()
    header = setFoamContents.makeFoamHeaderVersion(OFversion)
    foamFile = setFoamContents.makeFoamFile("2.0", "ascii", "dictionary",
                    "", "setFieldsDict")
    footer = setFoamContents.makeFooter()
    contents = header + foamFile + contents + footer
    return contents

def makeRegionsForBoxToCell(fields, fieldTypes):
    contents = ""
    contents += "    boxToCell\n"
    contents += "    {\n"
    contents += "        box (0 0 0) (1 1 1);\n"
    contents += "        fieldValues\n"
    contents += "        (\n"
    i = 0
    for fieldType in fieldTypes:
        if fieldType.find("Scalar") >= 0:
            fieldValue = fieldType + "Value " + fields[i] + " 0"
        elif fieldType.find("Vector") >= 0:
            fieldValue = fieldType + "Value " + fields[i] + " (0 0 0)"
        elif fieldType.find("SymmTensor") >= 0:
            fieldValue = fieldType + "Value " + fields[i] + " (0 0 0 0 0 0)"
        elif fieldType.find("Tensor") >= 0:
            fieldValue = fieldType + "Value " + fields[i] + " (0 0 0 0 0 0 0 0 0)"
        else:
            fieldValue = fieldType + "Value " + fields[i] + " 0"
        contents += "            " + fieldValue + "\n"
        i += 1
    contents += "        );\n"
    contents += "    }\n\n"
    return contents

def makeRegionsForSets(fields, fieldTypes, sets):
    contents = ""
    for cellSet in sets:
        contents += "    cellToCell\n"
        contents += "    {\n"
        contents += "        set " + cellSet + ";\n"
        contents += "        fieldValues\n"
        contents += "        (\n"
        i = 0
        for fieldType in fieldTypes:
            if fieldType.find("Scalar") >= 0:
                fieldValue = fieldType + "Value " + fields[i] + " 0"
            elif fieldType.find("Vector") >= 0:
                fieldValue = fieldType + "Value " + fields[i] + " (0 0 0)"
            elif fieldType.find("SymmTensor") >= 0:
                fieldValue = fieldType + "Value " + fields[i] + " (0 0 0 0 0 0)"
            elif fieldType.find("Tensor") >= 0:
                fieldValue = fieldType + "Value " + fields[i] + " (0 0 0 0 0 0 0 0 0)"
            else:
                fieldValue = fieldType + "Value " + fields[i] + " 0"
            contents += "            " + fieldValue + "\n"
            i += 1
        contents += "        );\n"
        contents += "    }\n\n"
    return contents

def getFieldType(field, nMaxLines):
    global timeFolder, selRegion
    fileName = "./" + timeFolder + "/" + selRegion + "/" + field
    #f=open(fileName); cont=f.read(); f.close()
    cont = getFoamContents.readFile2000Bytes(fileName)
    fieldType = getFoamContents.checkClass(cont)
    return fieldType

#  getSeledFieldsCellSets
#    setFieldsDict内容から選択しているfieldsとcellSetsを取得
def getSeledFieldsCellSets(caseDir, timeFolder, selRegion):
    fileName = caseDir + "/" + selRegion + "/system/setFieldsDict"
    if len(glob.glob(fileName)) == 0:
        return [[""], [""]]

    cellSets = []
    cellFields = []
    f=open(fileName); cont=f.read(); f.close()
    p = getFoamContents.skipFoamFileMem(cont, 0)
    [keyword, p] = getFoamContents.getKeywordMem(cont, p)
    while keyword != "regions" and keyword != "":
        if keyword == "defaultFieldValues":
            [valCont, p] = getFoamContents.getSmallPairMem(cont, p)
            words = valCont.split()
            i = 0
            while i<len(words):
                cellFields.append(words[i+1])
                i += 3
        [keyword, p] = getFoamContents.getKeywordMem(cont, p)
    if keyword != "regions":
        return [cellFields, cellSets]

    [regCont, p] = getFoamContents.getSmallPairMem(cont, p)
    [[keyword, cont], p] = getFoamContents.getNextKeywordAndContentsMem(regCont, 0)
    while keyword != "":
        if keyword == "cellToCell":
            [cellSet, fields] = getSetFieldsCellToCell(cont)
            cellSets.append(cellSet)
            cellFields += fields
        elif keyword == "boxToCell":
            [cellSet, fields] = getSetFieldsCellToCell(cont)
            cellFields += fields
        elif keyword == "cylinderToCell":
            [cellSet, fields] = getSetFieldsCellToCell(cont)
            cellFields += fields
        elif keyword == "sphereToCell":
            [cellSet, fields] = getSetFieldsCellToCell(cont)
            cellFields += fields
        [[keyword, cont], p] = getFoamContents.getNextKeywordAndContentsMem(regCont, p)
    cellSets = orderDelWlist(cellSets)
    cellFields = orderDelWlist(cellFields)
    return [cellFields, cellSets]

#  orderDelWlist
#    listから並べ替えとダブリを削除
def orderDelWlist(names):
    if len(names) == 0:
        return names
    names.sort()
    newNames = [names[0]]
    i = 1
    while i<len(names):
        if names[i-1] != names[i]:
            newNames.append(names[i])
        i += 1
    return newNames

#  getSetFieldsCellToCell
def getSetFieldsCellToCell(cont):
    cellSet = ""
    fields = []
    p = 0
    [keyword, p] = getFoamContents.getKeywordMem(cont, p)
    while keyword != "":
        if keyword == "set":
            [cellSet, p] = getFoamContents.getKeywordMem(cont, p)
        elif keyword == "fieldValues":
            [fieldCont, p] = getFoamContents.getSmallPairMem(cont, p)
            words = fieldCont.split()
            i = 0
            while i<len(words):
                field = words[i+1]
                fields.append(field)
                i += 3
        [keyword, p] = getFoamContents.getKeywordMem(cont, p)
    return [cellSet, fields]

#  getFielsCellSets
#    fieldとcellSetを取得
def getFieldsCellSets(caseDir, timeFolder, selRegion):
    global latestTime, startTime, firstTime, startFrom
    fieldDir = caseDir + "/" + timeFolder + "/" + selRegion
    fields = pyTreeFoam.getFieldNames(fieldDir)
    currTime = getFoamContents.getCurrTimeFolder(caseDir)
    polyMeshDir = getFoamContents.getCurrMeshDir(caseDir, currTime, selRegion, "sets")
    [cellSets, faceSets, pointSets] = topoSetEditor.getSetsFiles(polyMeshDir)
    return [fields, cellSets]


def initialize():
    global caseDir, timeFolder, selRegion, timeFolders, regionNames, startFrom, firstTime
    global latestTime, startTime, fields, cellSets, selFields, selCellSets
    #caseDirを絶対pathに変更
    if caseDir[0] != "/":
        caseDir = os.getcwd() + "/" + caseDir
    #timeFoldersを取得
    contDir = caseDir + "/system"
    [startFrom, startTime] = getFoamContents.controlDict(contDir, ["startFrom", "startTime"])
    timeFolders = pyTreeFoam.getTimeFolders(caseDir)
    firstTime = timeFolders[0]
    latestTime = timeFolders[-1]
    #regionsを取得
    regionNames = []
    [isRegion, loc, names] = pyTreeFoam.checkMultiRegion(caseDir)
    if isRegion == False:
        names = []
    regionNames.append(".")
    for name in names:
        regionNames.append(name)
    selRegion = regionNames[0]
    [fields, cellSets] = getFieldsCellSets(caseDir, timeFolder, selRegion)
    [selFields, selCellSets] = getSeledFieldsCellSets(caseDir, timeFolder, selRegion)



if __name__ == "__main__":
    import gettext
    treeFoamPath = os.environ["TreeFoamPath"]
    gettext.install("treefoam", treeFoamPath + "/data/locale")

    caseDir = sys.argv[1]
    timeFolder = sys.argv[2]
    initialize()
    wx.InitAllImageHandlers()
    app = wx.PySimpleApp(0)
    frame_2 = MyFrame(None, -1, "")
    app.SetTopWindow(frame_2)
    frame_2.Show()
    app.MainLoop()

