#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
#   startingTreeFoam.py
#
#       TreeFoamのstarting画面
#
#   13/12/21    新規作成
#   14/01/17    treeFoamがエラーで起動しなかった場合、starting画面が消えないので
#               300回のtimeEventが発生したら、画面を消すかどうかの選択画面を表示。
#
#


# generated by wxGlade 0.6.5 on Fri Dec 20 20:05:54 2013

import wx
import os
import glob

# begin wxGlade: extracode
# end wxGlade


version = ""
message = ""
close = "no"
limitTime = 300         #timeEventが累計で300回発生したら警告を発する
eventCount = 0


def Show():
    initialize()
    app = wx.PySimpleApp(0)
    wx.InitAllImageHandlers()
    frame_1 = MyFrame(None, -1, "")
    app.SetTopWindow(frame_1)
    frame_1.Show()
    app.MainLoop()

def initialize():
    global version, message
    names = glob.glob(os.getenv("TreeFoamPath") + "/Ver_*")
    version = names[0].split("/")[-1]
    message = ""


class MyFrame(wx.Frame):
    def __init__(self, *args, **kwds):
        global message, close
        # begin wxGlade: MyFrame.__init__
        kwds["style"] = wx.CAPTION | wx.CLOSE_BOX | wx.MINIMIZE_BOX | wx.MAXIMIZE_BOX | wx.STAY_ON_TOP | wx.SYSTEM_MENU | wx.SIMPLE_BORDER | wx.RESIZE_BORDER | wx.CLIP_CHILDREN
        wx.Frame.__init__(self, *args, **kwds)
        self.label_1 = wx.StaticText(self, -1, _("TreeFoam"))
        self.label_3 = wx.StaticText(self, -1, _("veision "))
        self.label_2 = wx.StaticText(self, -1, _("label_2"))

        self.__set_properties()
        self.__do_layout()
        # end wxGlade

        self.label_3.SetLabel(version)
        self.label_2.SetLabel(message)

        self.fileRead=open("./temp/startingInput.txt")
        self.Bind(wx.EVT_TIMER, self.onTimerEvent)
        self.timer = wx.Timer(self)
        self.timer.Start(100)


    def __set_properties(self):
        # begin wxGlade: MyFrame.__set_properties
        self.SetTitle(_("frame_1"))
        self.SetSize((400, 200))
        self.SetBackgroundColour(wx.Colour(207, 255, 211))
        self.label_1.SetFont(wx.Font(20, wx.DEFAULT, wx.NORMAL, wx.NORMAL, 0, "VL ゴシック"))
        # end wxGlade

    def __do_layout(self):
        # begin wxGlade: MyFrame.__do_layout
        sizer_1 = wx.BoxSizer(wx.VERTICAL)
        sizer_1.Add(self.label_1, 0, wx.TOP | wx.ALIGN_CENTER_HORIZONTAL, 50)
        sizer_1.Add(self.label_3, 0, wx.ALL | wx.ALIGN_CENTER_HORIZONTAL, 10)
        sizer_1.Add(self.label_2, 0, wx.LEFT | wx.TOP | wx.BOTTOM, 20)
        self.SetSizer(sizer_1)
        self.Layout()
        # end wxGlade

    #
    #  timerEvent
    #
    def onTimerEvent(self, event):
        global message, close, eventCount
        self.timer.Stop()
        eventCount += 1
        if eventCount < limitTime:
            message = self.fileRead.readline()
            if message[:5] == "close":
                close = "yes"
            if message != "":
                self.label_2.SetLabel(message)
            if close == "yes":
                self.Destroy()
            else:
                self.timer.Start(100)
        else:
            title = _(u"警告")
            mess = _(u"待ち時間がオーバしました。\n")
            mess += _(u"このまま継続しますか？\n")
            mess += _(u"  「はい」.... 起動するまで待つ\n")
            mess += _(u"  「いいえ」.. スタート画面を消す")
            ans = self.yesNoDialog(title,mess)
            if ans == "YES":
                self.timer.Start(100)
            else:
                self.Destroy()


    def yesNoDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                             wx.YES | wx.NO | wx.ICON_INFORMATION) 
        ans = dlg.ShowModal()
        stat = ""
        if ans == wx.ID_YES:
            stat = "YES"
        else:
            stat = "NO"
        return stat


# end of class MyFrame
if __name__ == "__main__":
    import gettext
    treeFoamPath = os.environ["TreeFoamPath"]
    gettext.install("treefoam", treeFoamPath + "/data/locale")

    initialize()
    app = wx.PySimpleApp(0)
    wx.InitAllImageHandlers()
    frame_1 = MyFrame(None, -1, "")
    app.SetTopWindow(frame_1)
    frame_1.Centre()
    frame_1.Show()
    app.MainLoop()

